// game.wdl
include <camera.wdl>;
var flash_percent= 0;


var video_mode = 7;
var video_depth = 16;
var video_screen = 1;
var d3d_anisotropy = 2;
var mip_shaded = 10;
var shadow_stencil = on;

var move_vec[3] = 0,0,0;
var idle_percent = 0;
var walk_percent = 0;
var run_percent = 0;
var temptilt = 0;

entity* dummy;
var move_vec2[3] = 0,0,0;
var idle_percent2 = 0;

var idle_percent = 0;

sound gun_shoot = <shot.wav>;
var shoot_handle;
var temp2[3];
var temp3[3];
var distance_covered = 0;
var counter=0;
entity* gun;
entity* muzzle_flash;

entity gun_onscreen
{
	type = <sterlingL2A3FS.mdl>;
	ambient = -30;
	x= 20;
	y= -7;
	z= -7;
	flags = visible;
	
}

entity clip
{
	type = <clip36.mdl>;
	flags = visible;
}

entity muzz_flash
{
	type = <muzzle_2.mdl>;
	flags = visible, overlay,transparent,flare,bright,nofog;
}

function init_muzzle
{
	wait(1);
	muzzle_flash.alpha=50;
	while(1)
	{
		while(muzzle_flash.alpha>0)
		{
			vec_for_vertex(muzzle_flash.x, gun,2269);
			vec_set(muzzle_flash.pan, gun.pan);
			muzzle_flash.alpha=max(0, muzzle_flash.alpha-time*50);
			wait(1);
		}
		wait(1);
	}
}



function ent_gun()
{
	
	wait(1);
	gun.material = mat_metal;
	clip.material = mat_metal;
	while (1)
	{
		
		vec_set(clip.x,gun.x);
		
		if(mouse_left && counter == 0)
		{
		   counter = 1;
		   snd_stop(shoot_handle);
		   wait(1);
	     	shoot_handle = snd_play(gun_shoot,90,0);
	     	muzzle_flash.alpha = 100; 		   
		   while (idle_percent2 <= 100)
		   {
		   	idle_percent2 += 60*time;
	      	ent_animate(gun,"shoot",idle_percent2,ANM_CYCLE);
	      	wait(1);
      	}
		}
		if ( idle_percent2 >= 100 && mouse_left != 0)
      {
      	
      	counter = 0;
      	idle_percent2 = 0;
      	shoot_handle = null;
		}
   	wait(1);
	}
}





action player_move
{
	my.trigger_range = 20;
	player = me;
	my.albedo = 75;
	my.ambient = 5;
	wait(1);
	camera.genius = player;
	shift_sense = 2;

	while (me != NULL)
	{  
		
	   move_vec[0] = (key_force.y)*5 *time;
	   
	   vec_set(temp.x,my.x);
	   temp.z -= 4000;
	   trace_mode = ignore_me +USE_BOX;
	   my.z -= trace(player.x,temp.x);
	   
	   player.pan += (-key_force.x)*5*time;
	   
	   move_mode = IGNORE_YOU + IGNORE_PASSABLE + IGNORE_PUSH + ACTIVATE_TRIGGER + GLIDE;
	   ent_move(move_vec,NULLVECTOR);
		
		If (move_vec[0] == 0  && move_vec[1] == 0)
		{
			idle_percent = (idle_percent +5*time)%100;
			ent_animate(me,"idle",idle_percent,ANM_CYCLE);
		}
		else	// our movement animations will go here
		{
			if (key_shift)  // either shift key is being pressed
			{
				run_percent = (run_percent + sign(move_vec[0])*5*time)%100;
				ent_animate(player,"run",run_percent,ANM_CYCLE); 
			}
			else // shift key is NOT being pressed so we are walking
			{
					walk_percent = (walk_percent + sign(move_vec[0])*5*time)%100;
					ent_animate(player,"walk",walk_percent,ANM_CYCLE);
			}
		}
		
		// camera updates
		1st_3rdcameras ();
		
	   wait(1);
	}
}



//////////////////////////////////////////////////////////////////////////////////////////////////
// mouse.wdl  mouse control
//////////////////////////////////////////////////////////////////////////////////////////////////
BMAP arrow = <arrow.pcx>; // image of mouse pointer
//BMAP d_font = <digifont.bmp>;
font d_font = <digifont.bmp>,0,14;

///////////////////////////////////////
function mouse_on()  // turn mouse on
{ 
	mouse_range = 10000;
	MOUSE_MAP = arrow;
	MOUSE_MODE = 2;
	
	
	while (MOUSE_MODE == 2)
	{ 
		MOUSE_POS.X = POINTER.X;
		MOUSE_POS.Y = POINTER.Y;
		wait(1);
	}
}
///////////////////////////////////////
function mouse_off()  // turn mouse off
{ 
	MOUSE_MODE = 0;
}
//////////////////////////////////////////////////////////////////////////////////////////////////


var d3d_lightres = on;


function main()
{
	tex_share = on;
	max_entities = 5000;
	freeze_mode = 1;
	level_load ("blacktest.wmb");
	wait(2);
	mouse_on();
	freeze_mode = 0;
	bg_color.red = 120;
	bg_color.green = 120;
	bg_color.blue = 80;
	detail_size = 8;
	
	var d3d_lightcone[0] = 40; // 90 degrees light cone
	var d3d_lightcone[1] = 30; // no darker aarea
	var d3d_lightcone[2] = 5; // no darker area
		
	init_cameras();
	wait(1);
	
	gun = gun_onscreen;
	muzzle_flash = muzz_flash;
	ent_gun();
	init_muzzle();
	
	
}
